/**
 * @author hanyaolong
 * @date 2019/08/12
 * @info 模型管理/模型文件管理
 */
import httputils from '@/utils/httputils'
const baseUrl = '/modelapi'

let api = {
    // 新建模型文件夹
    /**
     * 
     * @param {Name:string,ProjectId:string} params 
     */
    createModel(params) {
        let data = {
            Content: [params]
        };
        let Name = params.Name;
        // 查询是否有该模型文件夹
        return new Promise((reslove, reject) => {
            if(!Name){
                reslove('文件夹不能为空!')
            };
            this.queryModel(Name).then((res) => {
                if (res.Total == 0) {
                    // 创建
                    httputils.postJson(`${baseUrl}/model-folder/create`, data).then((res) => {
                        reslove(res.EntityList[0])
                    }).catch((err) => {
                        reject(err)
                    })
                } else {
                    reject('该文件夹已经创建!')
                }
            }).catch((err) => {
                reject(err)
            })
        })

    },
    //删除模型文件夹
    /**
     * 
     * @param {Id:string} params 
     */
    deleteModel(params) {
        let Content = [params]
        return new Promise((reslove,reject)=>{
            httputils.postJson(`${baseUrl}/model-folder/delete`,Content).then(res=>{
                reslove(res.Result)
            }).catch((err)=>{
                reject(err)
            })
        })
    },
    //修改模型文件夹名称
     /**
     * 
     * @param {Name:string,ProjectId:string} params 
     */
    updateModelName(params) {
        let data = {
            Content: [params]
        };
        let Name = params.Name;
        // 查询是否有该模型文件夹
        return new Promise((reslove, reject) => {
            if(!Name){
                reslove('文件夹名称不能为空!')
            };
            this.queryModel(Name).then((res) => {
                if (res.Total == 0) {
                    // 创建
                    httputils.postJson(`${baseUrl}/model-folder/update`, data).then((res) => {
                        reslove(res.Result)
                    }).catch((err) => {
                        reject(err)
                    })
                } else {
                    reject('该文件夹名称已存在!')
                }
            }).catch((err) => {
                reject(err)
            })
        })
    },
    //查询模型文件夹
    /** 
     * @param Name string  注:查询多个 Name = '' 
    */
    queryModel(Name) {
        let data = null;
        if(Name){
            // 单个查询
            data = {
                Filters: `Name='${Name}'` 
            }
        }else{
            // 多个查询
            data = {}
        }
        return httputils.postJson(`${baseUrl}/model-folder/query`, data)
    },



    //以下是楼层文件接口

    // 查询模型文件夹下的所有模型文件
    queryFloor(data){
        let params ={
            ProjectId:data.ProjectId,
            Filters:`folderId='${data.folderId}'`
        }
        return httputils.postJson(`${baseUrl}/model-floor/create`,params)
    },
    // 创建楼层文件
    createFloor(){
        return new Promise((reslove,reject)=>{
            httputils.postJson(`${baseUrl}/model-floor/create`, param).then((res)=>{
                if(res.Result == 'success'){
                    this.uploadModelFile(param).then((res)=>{
                          reslove(res)
                    })
                }else{
                    reject(res.Result )
                }
            }).catch((err)=>{
                reject(err)
            })
        })
    },
    // 删除楼层文件
    deleteFloor(data){
        return httputils.postJson(`${baseUrl}/model-floor/delete`, data)
    },
    //编辑楼层文件得名字
    updateFloorName(data){
        return httputils.postJson(`${baseUrl}/model-floor/update`, data)
    },


    //一下是楼层文件接口

    //删除模型文件
    deleteModelFile(data){
        return httputils.postJson(`${baseUrl}/model-file/delete`, data)
    },
    // 上传模型文件
    uploadModelFile(data){
        return httputils.postJson(`${baseUrl}/model-file/upload`, data)
    },
    //更新楼层文件
    upDateModelFile(){
        return httputils.postJson(`${baseUrl}/model-floor/update`, data)
    },
    //查询模型文件 
    queryModelFile(){
        return httputils.postJson(`${baseUrl}/model-floor/query`, data)
    }
    
}
export default api